
#pragma once

#include "Enemy.h"
#include "common.h"

#define MAX_ENEMY_COUNT      30			

class EnemyManager
{
private:
	static EnemyManager* m_pInstance;
protected:
	EnemyManager(){;}
public:
	static EnemyManager* GetInstance(void)
	{
		if ( m_pInstance == NULL )
			m_pInstance = new EnemyManager();

		return m_pInstance;
	}
private:
	Enemy Enemies[MAX_ENEMY_COUNT];
public:
	~EnemyManager(){;}
public:
	void Init(void);
	void EnemyAction(void);
	void DrawEnemy(void);
	bool CollisionWithShot(int _shotX, int _shotY);
	int CheckClear(void);
};

EnemyManager* EnemyManager::m_pInstance = NULL;

void EnemyManager::Init(void)
{
	int x = 17;
	int y = 1;
	int i;
	
	for ( i = 0; i < MAX_ENEMY_COUNT; i++ ) 
	{
		if ( i % 10 == 0 ) 
		{
			x = 17;
			y++;
		}
		
		Enemies[i].Init( x, y, x );
		Enemies[i].SetMoveFlag(1);

		x += ENEMY_SIZE + 1 + 1;
	}
}

void EnemyManager::EnemyAction(void)
{
	int i;
	
	for ( i = 0; i < MAX_ENEMY_COUNT; i++ ) 
	{
		Enemies[i].EnemyAction();
	}	
}

void EnemyManager::DrawEnemy(void)
{
	int i;
	
	for ( i = 0; i < MAX_ENEMY_COUNT; i++ ) 
	{
		Enemies[i].DrawEnemy();
	}
}

bool EnemyManager::CollisionWithShot(int _shotX, int _shotY)
{
	int i;
	
	for ( i = 0; i < MAX_ENEMY_COUNT; i++ ) 
	{
		if ( Enemies[i].GetLiveFlag() == 0 ) 
			continue;
		
		if ( Enemies[i].CollisionWithShot( _shotX, _shotY ) )
			return true;	//	 ġ Ѿ˰ 浹 ߻
	}
	return false;	//	ʹ̵ ߿  ġ Ѿ˰ 浹 ٴ ǹ
}

int EnemyManager::CheckClear(void)
{
	int i;
	
	for ( i = 0; i < MAX_ENEMY_COUNT; i++ ) 
	{
		if ( Enemies[i].GetLiveFlag() ) 
			return 0;
	}

	return 1;	
}